#include <avr/interrupt.h>
#include <avr/io.h>
#include "usart.h"
#include "lcd.h"
#include <avr/delay.h>


//--------------------------------------------------------------------------

// Defines
#define ZAEHNE = 25
#define UEBERSETZUNG_DIF = 3,9
#define UMFANG = 1,9		// Randumfang in cm
#define IMPULS_WEG = (UMFANG / UEBERSETZUNG_DIF / ZAEHNE)

// 100 km/h --> Impulsen
// 132 Impulse fr 1980mm Radumfang

// Grenzen 
// Zeile I:  0000.00	0000.00
// Zeile II

//Aufgaben: NAch 3420m rechts abbiegen

//--------------------------------------------------------------------------

// Global Variables 

unsigned int i = 0;
unsigned int j = 0;


//----------------------------------------------------------------------------



// External Interrupt 0 service routine
ISR(INT0_vect)       /* veraltet: SIGNAL(SIG_INTERRUPT0) */
{

cli();
if ((PIND && 0x04) == 1)
//if (debounce(PIND, 2))
    {   
		i++;
		PORTA |= ( 1 << 0 );
	}
	else PORTA &= ~0x01;
sei();



}

ISR (TIMER0_OVF_vect)
{
  /* Interrupt Aktion alle
  (1000000/8)/256 Hz = 488,28125 Hz
  bzw.
  1/488,28125 s = 2,048 ms  
  */
  
  
}
//------------------------------------------------------------------------------


void init_timer0(void)
{
// Init Timer0+OV-Interrupt
// Timer 0 konfigurieren
  TCCR0 = (1<<CS01); // Prescaler 8
 
  // Overflow Interrupt erlauben
  TIMSK |= (1<<TOIE0);
}


//-----------------------------------------------------------------------------


void init_extInt(void)
{
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;
}

void initPort(void)
{
// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;
} 
  






//------------------------------------------------------------------------------


int debounce(volatile int *port, int pin)
{
    if ( ! (*port & (1 << pin)) )
    {
        /* Pin wurde auf Masse gezogen, 100ms warten   */
        _delay_ms(5);  // max. 262.1 ms / F_CPU in MHz
        _delay_ms(5);
    
        if ( *port & (1 << pin) )
        {
            /* Anwender Zeit zum Loslassen des Tasters geben */
            _delay_ms(5);
            _delay_ms(5); 
            return 1;
        }
    }
    return 0;
}

//------------------------------------------------------------------------------


int main (void) 
{
	unsigned int a = 0;
	
	
	
	init_timer0();
	init_extInt();
	
	
	

	
	
	//usart_init(9600); // Serielle Schnittstelle initialisieren
	//usart_write("%2i LC-Display V1.5\r\n",a); 

	

	lcd_init();	
	
	lcd_clear();
	//lcd_print(0,0,"Impulse");
	lcd_print(1,0,"Strecke");
	//lcd_print(0,8,"%d cm/Imp",IMPULS_WEG);
	
	
	// Global Interrupts aktivieren
	sei();
	
	while(1)
	{
	  //#define IMPULS_WEG = (UMFANG * UEBERSETZUNG_DIF) / ZAEHNE
	  j = i*1.5;
	  
	  
	  if (a>50)
	  {
	    lcd_print(0,0,"%i",i);
	    lcd_print(1,8,"%i cm",j);
		
		PORTA |= (0x01);
		a = 0;
	  }
	  else a++;
	}
}

